Mae dwy borth gyflun wedi'u ffurfweddu â'r un allwedd a rennir ymlaen llaw yn cwblhau ysgwyd llaw, ac nid yw cipio pecynnau yn dangos unrhyw gyfrinach yn croesi'r wifren. Dyna'r rhan y mae pobl yn ei chofio. Y rhan ddiddorol yw'r hyn y mae pob fersiwn yn ei gyfrifo mewn gwirionedd i brofi bod y gyfrinach yn hysbys, oherwydd mae IKEv1 ac IKEv2 yn adeiladu'r prawf hwnnw o fewnbynnau gwahanol ac yn datgelu gwybodaeth wahanol wrth wneud hynny. Darllenwch y ddwy ôl ochr yn ochr ac mae'r gwahaniaeth yn peidio â bod yn addurnol.

Beth mae'r prawf i'w gyflawni

Mae Diffie-Hellman yn rhoi gwerth a rennir i'r ddau gymar y gall unrhyw un sy'n gwylio gyfrifo ei hannerau cyhoeddus hefyd. Ynddo'i hun nid yw hynny'n profi dim am hunaniaeth: mae gan ymosodwr sy'n cwblhau cyfnewid allwedd yr un gwerth a rennir â'ch porth. Mae'r cam dilysu yn bodoli i rwymo'r cyfnewid hwnnw i gyfrinach nad yw ond gan y cymar bwriadedig, ac i'r hunaniaethau a'r paramedrau y cytunwyd arnynt.

Y rhwymiad hwnnw yw'r rheswm y mae'r hash yn cynnwys mwy na'r allwedd. Pe bai'n cynnwys y gyfrinach yn unig, gallai ymosodwr ei hailchwarae i gyfnewid arall â hunaniaethau neu gynigion gwahanol.

IKEv1 Main Mode: deillio SKEYID, yna ei brofi

Mae Main Mode yn rhedeg chwe neges. Mae'r pâr cyntaf yn negodi'r gymdeithas ddiogelwch, mae'r ail yn cyfnewid gwerthoedd cyhoeddus Diffie-Hellman a nonces, ac mae'r trydydd yn cario hunaniaethau ynghyd â hashes dilysu o dan y cryptiad a sefydlwyd newydd. Mae RFC 2409 yn diffinio'r adeiladwaith: gyda dilysu ag allwedd a rennir ymlaen llaw, deillir SKEYID o'r gyfrinach a'r ddau nonce, a deillir y deunydd allweddol diweddarach o SKEYID, gwerth a rennir Diffie-Hellman, y cwcis a'r cysonion.

Mae'r hash ym mhumed a chweched neges yn cael ei gyfrifo dros werth Diffie-Hellman, y dau gwci, y cynnig a hunaniaeth yr anfonwr, wedi'i allweddu gan SKEYID. Mae'r derbynnydd yn ei ailgyfrifo gyda'i gyfrinach gyflun ei hun. Mae anghytundeb yn gorffen y cyfnewid, ac ar unrhyw adeg nid yw'r gyfrinach ei hun yn llwyth.

Mae Aggressive Mode yn cywasgu'r un gwaith i dair neges, sy'n golygu bod hunaniaethau a'r hash dilysu yn teithio cyn bod sianel gyfrinwedig yn bodoli. Mae hynny'n amlygiad gwirioneddol i gyfrinach y gellir ei dyfalu, ac mae'n wahanol i'r cwestiwn a drosglwyddwyd y gyfrinach. Mae IKEv1 wedi'i ddarbwyllo gan RFC 9395, felly mae ôl etifeddol yn ymarfer diagnostig yn hytrach na tharged defnyddio.

IKEv2: deilliad gwahanol a llwyth AUTH gwahanol

Nid yw IKEv2 yn ailddefnyddio amserlen allweddol IKEv1. Daw'r allweddi IKE cychwynnol o had a adeiladwyd o'r nonces a gwerth a rennir Diffie-Hellman, ac mae'r cymdeithasau diogelwch plentyn yn deillio o hynny. Nid yw'r allwedd a rennir ymlaen llaw yn bwydo'r had o gwbl.

Yna mae dilysu yn ymddangos fel llwyth AUTH. Ar gyfer dilysu ag allwedd a rennir, mae RFC 7296 yn nodi ffurf badiedig o'r gyfrinach, a gynhyrchir drwy hashio'r gyfrinach â'r llinyn sefydlog Key Pad for IKEv2, ac yna hashio'r data cyfnewid wedi'i lofnodi a'r hunaniaeth â'r allwedd badiedig honno. Gall y gwiriedydd ailadeiladu'r un gwerth; ni all sylwedydd, heb y gyfrinach.

Sylwch beth a newidiodd. Yn IKEv1 mae'r gyfrinach wedi'i phobi i mewn i'r amserlen allweddol cyn bod y hash dilysu yn bodoli; yn IKEv2 mae'r amserlen allweddol yn annibynnol o'r gyfrinach ac mae'r prawf yn llwyth ar wahân wedi'i rwymo i'r octetau wedi'u llofnodi. Yr un warant gysyniadol, peirianwaith gwahanol, a dyna pam nad yw enwau paramedrau a chipiadau yn mapio un i un.

Beth mae sylwedydd yn ei ddysgu mewn gwirionedd

Mae gwerthoedd cyhoeddus Diffie-Hellman, cynigion, nonces a chwcis yn weladwy yn y ddau fersiwn. Mae hunaniaethau yn weladwy yn IKEv1 Aggressive Mode ac wedi'u hamddiffyn yn yr achosion eraill. Nid yw'r gyfrinach byth yn weladwy.

Mae gan y frawddeg olaf hon derfyn sy'n werth ei nodi. Gellir ymosod ar gyfrinach wan a ddewiswyd gan berson drwy ddyfalu: mae'r ymosodwr yn cyfrifo beth fyddai'r gwerth dilysu ar gyfer ymgeisydd am gyfrinach ac yn cymharu. Mae IKEv1 Aggressive Mode yn gwneud hyn y rhataf oherwydd bod y dystiolaeth yn y golwg, ac mae'r safonau yn rhybuddio'n gyffredinol am gyfrinachau ag entropi isel. Nid yw peidio byth â throsglwyddo'r gyfrinach yr un peth â gwneud cyfrinach wael yn ddiogel.

Beth i'w wneud â'r gymhariaeth

Defnyddiwch un gyfrinach unigryw fesul pâr cymar, ei chynhyrchu o ffynhonnell ar hap, a'i throi drwy'r un llwybr darparu a'i dosbarthodd. Os yw'r gyfrinach yn cael ei storio mewn templed ffurfweddu a anfonir i bob cangen, mae cyfaddawd mewn un safle yn gyfaddawd ym mhob man.

Ffefrir dilysu sy'n seiliedig ar dystysgrifau lle mae'r gost weithredol yn dderbyniol, gan ei fod yn dileu'r broblem dyfalu cyfrinach a rennir ac yn rhoi hunaniaeth unigryw i bob cymar. Lle mae allwedd a rennir ymlaen llaw yn aros, cadwch hi'n hir, cyfyngwch ei chwmpas a thriniwch fersiwn IKE fel penderfyniad diogelwch yn hytrach na manylyn rhyngweithrededd.

Erthyglau cysylltiedig